## libsdl3 3.2.26+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

if(NOT DEFINED CMAKE_BUILD_TYPE)
  set(cmake_build_type_undefined 1)
endif()

# See docs/release_checklist.md
project(SDL3 LANGUAGES C VERSION "3.2.26")

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(SDL3_MAINPROJECT ON)
else()
  set(SDL3_MAINPROJECT OFF)
endif()

# Add UTF-8 encoding support for MSVC compiler.
# This ensures that the MSVC compiler interprets source files as UTF-8 encoded,
# which is useful for projects containing non-ASCII characters in source files.
add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")

# By default, configure SDL3 in RelWithDebInfo configuration
if(SDL3_MAINPROJECT)
  get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(is_multi_config)
      # The first item in CMAKE_CONFIGURATION_TYPES is the default configuration
      if(DEFINED CMAKE_CONFIGURATION_TYPES AND "RelWithDebInfo" IN_LIST CMAKE_CONFIGURATION_TYPES)
        list(REMOVE_ITEM CMAKE_CONFIGURATION_TYPES "RelWithDebInfo")
        list(INSERT CMAKE_CONFIGURATION_TYPES 0 "RelWithDebInfo")
        set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING "CMake configuration types" FORCE)
      endif()
  else()
    if(cmake_build_type_undefined)
      set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "CMake build type" FORCE)
    endif()
  endif()
endif()

# CMake 3.0 expands the "if(${A})" in "set(OFF 1);set(A OFF);if(${A})" to "if(1)"
# CMake 3.24+ emits a warning when not set.
unset(OFF)
unset(ON)
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckLanguage)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckStructHasMember)
include(CMakeDependentOption)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(GNUInstallDirs)

if(NOT DEFINED OpenGL_GL_PREFERENCE)
  set(OpenGL_GL_PREFERENCE GLVND)
endif()

find_package(PkgConfig)

list(APPEND CMAKE_MODULE_PATH "${SDL3_SOURCE_DIR}/cmake")
include("${SDL3_SOURCE_DIR}/cmake/macros.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlchecks.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlcompilers.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlcpu.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlmanpages.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlplatform.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdltargets.cmake")
include("${SDL3_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake")
include("${SDL3_SOURCE_DIR}/cmake/3rdparty.cmake")
include("${SDL3_SOURCE_DIR}/cmake/PreseedMSVCCache.cmake")
include("${SDL3_SOURCE_DIR}/cmake/PreseedEmscriptenCache.cmake")

SDL_DetectCompiler()
SDL_DetectTargetCPUArchitectures(SDL_CPUS)
if(APPLE AND CMAKE_OSX_ARCHITECTURES)
  list(LENGTH CMAKE_OSX_ARCHITECTURES _num_arches)
  if(_num_arches GREATER 1)
    set(APPLE_MULTIARCH TRUE)
  endif()
endif()

# Increment this if there is an incompatible change - but if that happens,
# we should rename the library from SDL3 to SDL4, at which point this would
# reset to 0 anyway.
set(SDL_SO_VERSION_MAJOR "0")
set(SDL_SO_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(SDL_SO_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(SDL_SO_VERSION "${SDL_SO_VERSION_MAJOR}.${SDL_SO_VERSION_MINOR}.${SDL_SO_VERSION_PATCH}")

if(PROJECT_VERSION_MINOR MATCHES "[02468]$")
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${PROJECT_VERSION_MINOR} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "${PROJECT_VERSION_PATCH}")
else()
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${PROJECT_VERSION_MINOR} + ${PROJECT_VERSION_PATCH} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "0")
endif()
set(SDL_DYLIB_CURRENT_VERSION_PATCH "0")
set(SDL_DYLIB_COMPAT_VERSION_PATCH "0")

set(SDL_DYLIB_CURRENT_VERSION "${SDL_DYLIB_CURRENT_VERSION_MAJOR}.${SDL_DYLIB_CURRENT_VERSION_MINOR}.${SDL_DYLIB_CURRENT_VERSION_PATCH}")
set(SDL_DYLIB_COMPAT_VERSION "${SDL_DYLIB_COMPAT_VERSION_MAJOR}.${SDL_DYLIB_COMPAT_VERSION_MINOR}.${SDL_DYLIB_COMPAT_VERSION_PATCH}")

message(DEBUG "SDL_SO_VERSION=${SDL_SO_VERSION} SDL_DYLIB_CURRENT_VERSION=${SDL_DYLIB_CURRENT_VERSION} SDL_DYLIB_COMPAT_VERSION=${SDL_DYLIB_COMPAT_VERSION}")

set(SDL_FRAMEWORK_VERSION "A")

set(SDL_CHECK_REQUIRED_INCLUDES "" CACHE STRING "Extra includes (for CMAKE_REQUIRED_INCLUDES)")
set(SDL_CHECK_REQUIRED_LINK_OPTIONS "" CACHE STRING "Extra link options (for CMAKE_REQUIRED_LINK_OPTIONS)")
mark_as_advanced(SDL_CHECK_REQUIRED_INCLUDES SDL_CHECK_REQUIRED_LINK_OPTIONS)

string(APPEND CMAKE_REQUIRED_FLAGS " -D_GNU_SOURCE=1")
list(APPEND CMAKE_REQUIRED_INCLUDES ${SDL_CHECK_REQUIRED_INCLUDES})
list(APPEND CMAKE_REQUIRED_LINK_OPTIONS ${SDL_CHECK_REQUIRED_LINK_OPTIONS})

# Get the platform
SDL_DetectCMakePlatform()

# Don't mistake macOS for unix
if(UNIX AND NOT ANDROID AND NOT APPLE AND NOT RISCOS)
  set(UNIX_SYS ON)
else()
  set(UNIX_SYS OFF)
endif()

if(UNIX OR APPLE)
  set(UNIX_OR_MAC_SYS ON)
else()
  set(UNIX_OR_MAC_SYS OFF)
endif()

# Emscripten pthreads work, but you need to have a non-pthread fallback build
#  for systems without support. It's not currently enough to not use
#  pthread functions in a pthread-build; it won't start up on unsupported
#  browsers. As such, you have to explicitly enable it on Emscripten builds
#  for the time being. This default will change to ON once this becomes
#  commonly supported in browsers or the Emscripten team makes a single
#  binary work everywhere.
if (UNIX_OR_MAC_SYS AND NOT EMSCRIPTEN)
  set(SDL_PTHREADS_DEFAULT ON)
else()
  set(SDL_PTHREADS_DEFAULT OFF)
endif()

if(UNIX_SYS OR ANDROID)
  set(SDL_CLOCK_GETTIME_DEFAULT ON)
else()
  set(SDL_CLOCK_GETTIME_DEFAULT OFF)
endif()

# The hidraw support doesn't catch Xbox, PS4 and Nintendo controllers,
#  so we'll just use libusb when it's available. libusb does not support iOS,
#  so we default to yes on iOS.
if(IOS OR TVOS OR VISIONOS OR WATCHOS OR ANDROID)
  set(SDL_HIDAPI_LIBUSB_AVAILABLE FALSE)
else()
  set(SDL_HIDAPI_LIBUSB_AVAILABLE TRUE)
endif()

set(SDL_ASSEMBLY_DEFAULT OFF)
if(USE_CLANG OR USE_GCC OR USE_INTELCC OR MSVC_VERSION GREATER 1400)
  set(SDL_ASSEMBLY_DEFAULT ON)
endif()

set(SDL_GCC_ATOMICS_DEFAULT OFF)
if(USE_GCC OR USE_CLANG OR USE_INTELCC OR USE_QCC)
  set(SDL_GCC_ATOMICS_DEFAULT ON)
endif()

# Default option knobs
set(SDL_LIBC_DEFAULT ON)
set(SDL_SYSTEM_ICONV_DEFAULT ON)
if(WINDOWS OR MACOS OR IOS OR TVOS OR VISIONOS OR WATCHOS)
  set(SDL_SYSTEM_ICONV_DEFAULT OFF)
endif()

set(SDL_RELOCATABLE_DEFAULT OFF)
if(MSVC)
  set(SDL_RELOCATABLE_DEFAULT ON)
endif()

set(SDL_SHARED_DEFAULT ON)
set(SDL_STATIC_DEFAULT ON)

set(SDL_SHARED_AVAILABLE ON)
set(SDL_STATIC_AVAILABLE ON)

# All these *_DEFAULT vars will default to ON if not specified,
# so you only need to override them if they need to be disabled.
if(EMSCRIPTEN)
  # Set up default values for the currently supported set of subsystems:
  # Emscripten/Javascript does not have assembly support, a dynamic library
  # loading architecture, or low-level CPU inspection.
  set(SDL_ASSEMBLY_DEFAULT OFF)
  set(SDL_SHARED_AVAILABLE OFF)
endif()

if(VITA OR PSP OR PS2 OR N3DS OR RISCOS)
  set(SDL_SHARED_AVAILABLE OFF)
endif()

if((RISCOS OR UNIX_SYS) AND NOT (LINUX OR NETBSD OR OPENBSD))
  set(SDL_OSS_DEFAULT ON)
else()
  set(SDL_OSS_DEFAULT OFF)
endif()

if(SDL_SHARED_DEFAULT AND SDL_STATIC_DEFAULT AND SDL_SHARED_AVAILABLE)
  if(DEFINED BUILD_SHARED_LIBS)
    # When defined, use BUILD_SHARED_LIBS as default
    if(BUILD_SHARED_LIBS)
      set(SDL_STATIC_DEFAULT OFF)
    else()
      set(SDL_SHARED_DEFAULT OFF)
    endif()
  else()
    # Default to just building the shared library
    set(SDL_STATIC_DEFAULT OFF)
  endif()
endif()

dep_option(SDL_DEPS_SHARED "Load dependencies dynamically" ON SDL_SHARED_AVAILABLE OFF)

set(SDL_SUBSYSTEMS )

macro(define_sdl_subsystem _name)
  cmake_parse_arguments("_ds" "" "" "DEPS" ${ARGN})
  string(TOUPPER ${_name} _uname)
  if(NOT DEFINED SDL_${_uname}_DEFAULT)
    set(SDL_${_uname}_DEFAULT ON)
  endif()
  if(_ds_DEPS)
    cmake_dependent_option(SDL_${_uname} "Enable the ${_name} subsystem" "${SDL_${_uname}_DEFAULT}" "${_ds_DEPS}" OFF)
  else()
    option(SDL_${_uname} "Enable the ${_name} subsystem" "${SDL_${_uname}_DEFAULT}")
  endif()
  list(APPEND SDL_SUBSYSTEMS "${_name}")
endmacro()

define_sdl_subsystem(Audio)
define_sdl_subsystem(Video)
define_sdl_subsystem(GPU DEPS SDL_VIDEO)
define_sdl_subsystem(Render DEPS SDL_VIDEO)
define_sdl_subsystem(Camera DEPS SDL_VIDEO)
define_sdl_subsystem(Joystick)
define_sdl_subsystem(Haptic)
define_sdl_subsystem(Hidapi)
define_sdl_subsystem(Power)
define_sdl_subsystem(Sensor)
define_sdl_subsystem(Dialog)

cmake_dependent_option(SDL_FRAMEWORK "Build SDL libraries as Apple Framework" OFF "APPLE" OFF)
if(SDL_FRAMEWORK)
  set(SDL_STATIC_AVAILABLE FALSE)
endif()

if(UNIX AND NOT ANDROID AND NOT RISCOS AND NOT SDL_FRAMEWORK)
  set(SDL_RPATH_DEFAULT ON)
else()
  set(SDL_RPATH_DEFAULT OFF)
endif()

set(SDL_PRESEED_AVAILABLE OFF)
if(COMMAND SDL_Preseed_CMakeCache)
  set(SDL_PRESEED_AVAILABLE ON)
endif()

set(SDL_X11_XRANDR_DEFAULT ON)
if(SOLARIS)
  set(SDL_X11_XRANDR_DEFAULT OFF)
endif()

# Allow some projects to be built conditionally.
set_option(SDL_INSTALL             "Enable installation of SDL3" ${SDL3_MAINPROJECT})
cmake_dependent_option(SDL_INSTALL_CPACK "Create binary SDL3 archive using CPack" ${SDL3_MAINPROJECT} "SDL_INSTALL" ON)
cmake_dependent_option(SDL_INSTALL_DOCS "Install docs for SDL3" OFF "SDL_INSTALL;NOT SDL_FRAMEWORK" ON)
set_option(SDL_UNINSTALL           "Enable uninstallation of SDL3" ${SDL3_MAINPROJECT})
cmake_dependent_option(SDL_PRESEED "Preseed CMake cache to speed up configuration" ON "${SDL_PRESEED_AVAILABLE}" OFF)
cmake_dependent_option(SDL_RELOCATABLE "Create relocatable SDL package" ${SDL_RELOCATABLE_DEFAULT} "SDL_INSTALL" OFF)

cmake_dependent_option(SDL_ANDROID_JAR  "Enable creation of SDL3.jar" ${SDL3_MAINPROJECT} "ANDROID" ON)

option_string(SDL_ASSERTIONS "Enable internal sanity checks (auto/disabled/release/enabled/paranoid)" "auto")
set_option(SDL_ASSEMBLY            "Enable assembly routines" ${SDL_ASSEMBLY_DEFAULT})
dep_option(SDL_AVX                 "Use AVX assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_AVX2                "Use AVX2 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_AVX512F             "Use AVX512F assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE                 "Use SSE assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE2                "Use SSE2 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE3                "Use SSE3 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE4_1              "Use SSE4.1 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE4_2              "Use SSE4.2 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_MMX                 "Use MMX assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_ALTIVEC             "Use Altivec assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_POWERPC32 OR SDL_CPU_POWERPC64" OFF)
dep_option(SDL_ARMNEON             "Use NEON assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_ARM32 OR SDL_CPU_ARM64" OFF)
dep_option(SDL_LSX                 "Use LSX assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_LOONGARCH64" OFF)
dep_option(SDL_LASX                "Use LASX assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_LOONGARCH64" OFF)

=== examples/CMakeLists.txt ===
#
# CMake script for building the SDL examples
#

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../cmake")

include(CheckIncludeFile)
include(CheckStructHasMember)
include(CMakePushCheckState)
include(sdlcompilers)

if(SDL_EXAMPLES_LINK_SHARED)
    set(sdl_name_component SDL3-shared)
else()
    set(sdl_name_component SDL3-static)
endif()
set(HAVE_EXAMPLES_LINK_SHARED "${SDL_EXAMPLES_LINK_SHARED}" PARENT_SCOPE)

# CMake incorrectly detects opengl32.lib being present on MSVC ARM64
if(NOT (MSVC AND SDL_CPU_ARM64))
    # Prefer GLVND, if present
    set(OpenGL_GL_PREFERENCE GLVND)
    find_package(OpenGL)
endif()

set(SDL_EXAMPLE_EXECUTABLES)

if(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set(example_bin_dir "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
    if(NOT IS_ABSOLUTE "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
        set(example_bin_dir "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
    endif()
else()
    set(example_bin_dir "${CMAKE_CURRENT_BINARY_DIR}")
endif()
if(NOT CMAKE_VERSION VERSION_LESS 3.20)
    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    set(example_bin_dir "${example_bin_dir}$<$<BOOL:${is_multi_config}>:/$<CONFIG>>")
endif()

file(GLOB RESOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/*.bmp ${CMAKE_CURRENT_SOURCE_DIR}/../test/*.wav ${CMAKE_CURRENT_SOURCE_DIR}/../test/*.hex)

set(RESOURCE_FILE_NAMES)
set(RESOURCE_FILES_BINDIR)
foreach(resource_file IN LISTS RESOURCE_FILES)
    get_filename_component(res_file_name ${resource_file} NAME)
    list(APPEND RESOURCE_FILE_NAMES "${res_file_name}")
    set(resource_file_bindir "${example_bin_dir}/${res_file_name}")
    add_custom_command(OUTPUT "${resource_file_bindir}"
        COMMAND "${CMAKE_COMMAND}" -E copy "${resource_file}" "${resource_file_bindir}"
        DEPENDS "${resource_file}"
    )
    list(APPEND RESOURCE_FILES_BINDIR "${resource_file_bindir}")
endforeach()
add_custom_target(copy-sdl-example-resources
    DEPENDS "${RESOURCE_FILES_BINDIR}"
)

macro(add_sdl_example_executable TARGET)
    cmake_parse_arguments(AST "BUILD_DEPENDENT" "" "SOURCES;DATAFILES" ${ARGN})
    if(AST_UNPARSED_ARGUMENTS)
        message(FATAL_ERROR "Unknown argument(s): ${AST_UNPARSED_ARGUMENTS}")
    endif()
    if(NOT AST_SOURCES)
        message(FATAL_ERROR "add_sdl_example_executable needs at least one source")
    endif()
    set(EXTRA_SOURCES "")
    if(AST_DATAFILES)
        list(APPEND EXTRA_SOURCES ${DATAFILES})
    endif()
    if(ANDROID)
        add_library(${TARGET} SHARED ${AST_SOURCES} ${EXTRA_SOURCES})
    else()
        add_executable(${TARGET} ${AST_SOURCES} ${EXTRA_SOURCES})
    endif()
    SDL_AddCommonCompilerFlags(${TARGET})
    target_include_directories(${TARGET} PRIVATE "${SDL3_SOURCE_DIR}/src/video/khronos")
    target_link_libraries(${TARGET} PRIVATE SDL3::${sdl_name_component})

    list(APPEND SDL_EXAMPLE_EXECUTABLES ${TARGET})
    if(AST_DATAFILES)
        if(PSP OR PS2)
            add_custom_command(TARGET ${TARGET} POST_BUILD
                COMMAND ${CMAKE_COMMAND} ARGS -E make_directory $<TARGET_FILE_DIR:${TARGET}>/sdl-${TARGET}
                COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different ${AST_DATAFILES} $<TARGET_FILE_DIR:${TARGET}>/sdl-${TARGET}
                WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            )
        else()
            add_dependencies(${TARGET} copy-sdl-example-resources)
        endif()
        if(APPLE)
            # Make sure resource files get installed into macOS/iOS .app bundles.
            set_target_properties(${TARGET} PROPERTIES RESOURCE "${AST_DATAFILES}")
        endif()
        if(EMSCRIPTEN)
            foreach(res IN LISTS AST_DATAFILES)
                get_filename_component(res_name "${res}" NAME)
                target_link_options(${TARGET} PRIVATE "SHELL:--embed-file ${res}@${res_name}")
            endforeach()
        endif()
        set_property(TARGET ${TARGET} APPEND PROPERTY ADDITIONAL_CLEAN_FILES "$<TARGET_FILE_DIR:${TARGET}>/$<JOIN:${AST_DATAFILES},$<SEMICOLON>$<TARGET_FILE_DIR:${TARGET}>/>")
    endif()

    if(WINDOWS)
        # CET support was added in VS 16.7
        if(MSVC_VERSION GREATER 1926 AND CMAKE_GENERATOR_PLATFORM MATCHES "Win32|x64")
            set_property(TARGET ${TARGET} APPEND_STRING PROPERTY LINK_FLAGS " -CETCOMPAT")
        endif()
    elseif(PSP)
        target_link_libraries(${TARGET} PRIVATE GL)
    elseif(EMSCRIPTEN)
        set_property(TARGET ${TARGET} PROPERTY SUFFIX ".html")
        target_link_options(${TARGET} PRIVATE -sALLOW_MEMORY_GROWTH=1)
    endif()

    if(OPENGL_FOUND)
        target_compile_definitions(${TARGET} PRIVATE HAVE_OPENGL)
    endif()

    # FIXME: only add "${SDL3_BINARY_DIR}/include-config-$<LOWER_CASE:$<CONFIG>>" + include paths of external dependencies
    target_include_directories(${TARGET} PRIVATE "$<TARGET_PROPERTY:SDL3::${sdl_name_component},INCLUDE_DIRECTORIES>")
endmacro()

add_sdl_example_executable(renderer-clear SOURCES renderer/01-clear/clear.c)
add_sdl_example_executable(renderer-primitives SOURCES renderer/02-primitives/primitives.c)
add_sdl_example_executable(renderer-lines SOURCES renderer/03-lines/lines.c)
add_sdl_example_executable(renderer-points SOURCES renderer/04-points/points.c)
add_sdl_example_executable(renderer-rectangles SOURCES renderer/05-rectangles/rectangles.c)
add_sdl_example_executable(renderer-textures SOURCES renderer/06-textures/textures.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-streaming-textures SOURCES renderer/07-streaming-textures/streaming-textures.c)
add_sdl_example_executable(renderer-rotating-textures SOURCES renderer/08-rotating-textures/rotating-textures.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-scaling-textures SOURCES renderer/09-scaling-textures/scaling-textures.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-geometry SOURCES renderer/10-geometry/geometry.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-color-mods SOURCES renderer/11-color-mods/color-mods.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-viewport SOURCES renderer/14-viewport/viewport.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-cliprect SOURCES renderer/15-cliprect/cliprect.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-read-pixels SOURCES renderer/17-read-pixels/read-pixels.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp)
add_sdl_example_executable(renderer-debug-text SOURCES renderer/18-debug-text/debug-text.c)
add_sdl_example_executable(audio-simple-playback SOURCES audio/01-simple-playback/simple-playback.c)
add_sdl_example_executable(audio-simple-playback-callback SOURCES audio/02-simple-playback-callback/simple-playback-callback.c)
add_sdl_example_executable(audio-load-wav SOURCES audio/03-load-wav/load-wav.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.wav)
add_sdl_example_executable(audio-multiple-streams SOURCES audio/04-multiple-streams/multiple-streams.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.wav ${CMAKE_CURRENT_SOURCE_DIR}/../test/sword.wav)
add_sdl_example_executable(input-joystick-polling SOURCES input/01-joystick-polling/joystick-polling.c)
add_sdl_example_executable(input-joystick-events SOURCES input/02-joystick-events/joystick-events.c)
add_sdl_example_executable(camera-read-and-draw SOURCES camera/01-read-and-draw/read-and-draw.c)
add_sdl_example_executable(pen-drawing-lines SOURCES pen/01-drawing-lines/drawing-lines.c)
add_sdl_example_executable(asyncio-load-bitmaps SOURCES asyncio/01-load-bitmaps/load-bitmaps.c DATAFILES ${CMAKE_CURRENT_SOURCE_DIR}/../test/sample.bmp ${CMAKE_CURRENT_SOURCE_DIR}/../test/gamepad_front.bmp ${CMAKE_CURRENT_SOURCE_DIR}/../test/speaker.bmp ${CMAKE_CURRENT_SOURCE_DIR}/../test/icon2x.bmp)
add_sdl_example_executable(demo-snake SOURCES demo/01-snake/snake.c)
add_sdl_example_executable(demo-woodeneye-008 SOURCES demo/02-woodeneye-008/woodeneye-008.c)
add_sdl_example_executable(demo-infinite-monkeys SOURCES demo/03-infinite-monkeys/infinite-monkeys.c)
add_sdl_example_executable(demo-bytepusher SOURCES demo/04-bytepusher/bytepusher.c)

# When you add an example, remember to add the Visual Studio project as well:
# - Add a new example in examples/
# - Run python VisualC/examples/generate.py
# - Take note of the newly generated .vcxproj files
# - Modify the .vcxproj files if necessary (adding content such as BMP or WAV files)
# - Open VisualC/SDL.sln in Visual Studio or JetBrains Rider
# - Locate the appropriate folder in the Solution Explorer
# - Add the newly generated projects: Right click -> Add -> Existing project...
# - Test if they work
# - Save the SDL.sln solution

if(PSP)
    # Build EBOOT files if building for PSP
    foreach(APP ${SDL_EXAMPLE_EXECUTABLES})
        create_pbp_file(
            TARGET          ${APP}
            TITLE           SDL-${APP}
            ICON_PATH       NULL
            BACKGROUND_PATH NULL
            PREVIEW_PATH    NULL
            OUTPUT_DIR      $<TARGET_FILE_DIR:${APP}>/sdl-${APP}
        )
    endforeach()
endif()

if(N3DS)
    set(ROMFS_DIR "${CMAKE_CURRENT_BINARY_DIR}/romfs")
    file(MAKE_DIRECTORY "${ROMFS_DIR}")
    file(COPY ${RESOURCE_FILES} DESTINATION "${ROMFS_DIR}")

    foreach(APP ${SDL_EXAMPLE_EXECUTABLES})
        get_target_property(TARGET_BINARY_DIR ${APP} BINARY_DIR)
        set(SMDH_FILE "${TARGET_BINARY_DIR}/${APP}.smdh")
        ctr_generate_smdh("${SMDH_FILE}"
            NAME "SDL-${APP}"
            DESCRIPTION "SDL3 Test suite"
            AUTHOR "SDL3 Contributors"
            ICON "${CMAKE_CURRENT_SOURCE_DIR}/../test/n3ds/logo48x48.png"
        )
        ctr_create_3dsx(
            ${APP}
            ROMFS "${ROMFS_DIR}"
            SMDH "${SMDH_FILE}"
        )
    endforeach()
endif()

if(RISCOS)
    set(SDL_EXAMPLE_EXECUTABLES_AIF)
    foreach(APP ${SDL_EXAMPLE_EXECUTABLES})
        set_property(TARGET ${APP} APPEND_STRING PROPERTY LINK_FLAGS " -static")
        add_custom_command(
            OUTPUT ${APP},ff8
            COMMAND elf2aif ${APP} ${APP},ff8
            DEPENDS ${APP}
        )
        add_custom_target(${APP}-aif ALL DEPENDS ${APP},ff8)
        list(APPEND SDL_EXAMPLE_EXECUTABLES_AIF ${CMAKE_CURRENT_BINARY_DIR}/${APP},ff8)
    endforeach()
endif()

# Set Apple App ID / Bundle ID.  This is needed to launch apps on some Apple
# platforms (iOS, for example).
if(APPLE)
  foreach(CURRENT_TARGET ${SDL_EXAMPLE_EXECUTABLES})
    set_target_properties("${CURRENT_TARGET}" PROPERTIES
      MACOSX_BUNDLE_GUI_IDENTIFIER "org.libsdl.${CURRENT_TARGET}"
      MACOSX_BUNDLE_BUNDLE_VERSION "${SDL3_VERSION}"
      MACOSX_BUNDLE_SHORT_VERSION_STRING "${SDL3_VERSION}"
    )
  endforeach()
endif()

if(SDL_INSTALL_EXAMPLES)
    if(RISCOS)
        install(
            FILES ${SDL_EXAMPLE_EXECUTABLES_AIF}
            DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/installed-examples/SDL3
        )
    else()
        install(
            TARGETS ${SDL_EXAMPLE_EXECUTABLES}
            DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/installed-examples/SDL3
        )
    endif()
    if(MSVC)
        foreach(example IN LISTS SDL_EXAMPLE_EXECUTABLES)
            SDL_install_pdb(${example} "${CMAKE_INSTALL_LIBEXECDIR}/installed-examples/SDL3")
        endforeach()
    endif()
    install(
        FILES ${RESOURCE_FILES}
        DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/installed-examples/SDL3
    )
endif()

if(ANDROID AND TARGET SDL3::Jar)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../cmake/android")
    find_package(SdlAndroid MODULE)
    if(SdlAndroid_FOUND)
        set(apks "")
        set(packages "")

        include(SdlAndroidFunctions)
        sdl_create_android_debug_keystore(SDL_example-debug-keystore)

=== src/hidapi/hidtest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3...3.25 FATAL_ERROR)
project(hidtest C)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    # hidtest is build as a standalone project

    if(POLICY CMP0074)
        # allow using hidapi_ROOT if CMake supports it
        cmake_policy(SET CMP0074 NEW)
    endif()

    find_package(hidapi 0.12 REQUIRED)
    message(STATUS "Using HIDAPI: ${hidapi_VERSION}")
else()
    # hidtest is built as part of the main HIDAPI build
    message(STATUS "Building hidtest")
endif()

set(HIDAPI_HIDTEST_TARGETS)
if(NOT WIN32 AND NOT APPLE AND CMAKE_SYSTEM_NAME MATCHES "Linux")
    if(TARGET hidapi::hidraw)
        add_executable(hidtest_hidraw test.c)
        target_link_libraries(hidtest_hidraw hidapi::hidraw)
        list(APPEND HIDAPI_HIDTEST_TARGETS hidtest_hidraw)
    endif()
    if(TARGET hidapi::libusb)
        add_executable(hidtest_libusb test.c)
        target_compile_definitions(hidtest_libusb PRIVATE USING_HIDAPI_LIBUSB)
        target_link_libraries(hidtest_libusb hidapi::libusb)
        list(APPEND HIDAPI_HIDTEST_TARGETS hidtest_libusb)
    endif()
else()
    add_executable(hidtest test.c)
    target_link_libraries(hidtest hidapi::hidapi)
    list(APPEND HIDAPI_HIDTEST_TARGETS hidtest)
endif()

install(TARGETS ${HIDAPI_HIDTEST_TARGETS}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)

=== debian/changelog ===
libsdl3 (3.2.26+ds-2) unstable; urgency=medium

  * d/patches: Add post-release bug fixes from upstream git up to
    release-3.2.x commit release-3.2.26-9-g4ae517e24e, excluding
    CI- and D3D-specific changes

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Nov 2025 15:22:00 +0000

libsdl3 (3.2.26+ds-1) unstable; urgency=medium

  * New upstream stable release
  * d/patches: Drop patches that were included in the upstream release

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Oct 2025 16:49:41 +0000

=== debian/control ===
Source: libsdl3
X-Style: black
Priority: optional
Section: libs
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Manuel A. Fernandez Montecelo <mafm@debian.org>,
 Felix Geyer <fgeyer@debian.org>,
 Simon McVittie <smcv@debian.org>,
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 fcitx-libs-dev,
 glslang-tools (>= 12),
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev (>= 0.2.0) [linux-any],
 libdrm-dev [linux-any],
 libegl-dev,
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev,
 libibus-1.0-dev,
 libpipewire-0.3-dev (>= 0.3.44) [linux-any],
 libpulse-dev,
 libsndio-dev,
 libudev-dev [linux-any],
 liburing-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libvulkan-dev,
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 ninja-build,
 pkgconf,
 wayland-protocols,
 xxd,
Build-Depends-Indep:
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl3.git
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl3
Homepage: https://www.libsdl.org/

Package: libsdl3-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libdbus-1-3,
 libegl1,
 libgl1 | libopengl0,
 libgles2,
 libudev1 [linux-any],
Suggests:
 libayatana-appindicator3-1 | libappindicator3-1,
 libpipewire-0.3-0t64 [linux-any],
 liburing2 [linux-any],
 libvulkan1,
 xdg-utils,
Description: Simple DirectMedia Layer, version 3
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the shared library.

Package: libsdl3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev (>= 0.2.0) [linux-any],
 libdrm-dev [linux-any],
 libegl-dev,
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev,
 libibus-1.0-dev,
 libpipewire-0.3-dev (>= 0.3.44) [linux-any],
 libpulse-dev,
 libsdl3-0 (= ${binary:Version}),
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Simple DirectMedia Layer, version 3 development files
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Breaks:
 libsdl1.2-dev (<< 1.2.64),
Replaces:
 libsdl1.2-dev (<< 1.2.64),
Description: Reference manual for SDL 3
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the reference manual and examples.

Package: libsdl3-tests
Section: misc
Architecture: any
Build-Profiles: <!noinsttest>
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 gnome-desktop-testing,
Description: Simple DirectMedia Layer automated and manual tests
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains manual and automated tests. The automated tests can
 be run using ginsttest-runner in the gnome-desktop-testing package,
 or manually.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

built_binaries := $(shell dh_listpackages)

include /usr/share/dpkg/default.mk

export SDL_AUDIO_DRIVER=dummy
export SDL_VIDEO_DRIVER=dummy

# Upstream test timeouts assume a gaming-capable system.
# Keep the timeout reasonably short for architectures where interactive
# debugging is more likely, but extend it a lot on architectures that might
# be very slow or using qemu for buildds.
ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
test_timeout_multiplier = 3
else
test_timeout_multiplier = 20
endif

confflags = \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DSDL_ALSA_SHARED=OFF \
	-DSDL_DEPS_SHARED=OFF \
	-DSDL_EXAMPLES=ON \
	-DSDL_HIDAPI_LIBUSB_SHARED=OFF \
	-DSDL_JACK=OFF \
	-DSDL_JACK_SHARED=OFF \
	-DSDL_KMSDRM_SHARED=OFF \
	-DSDL_OSS=OFF \
	-DSDL_PULSEAUDIO_SHARED=OFF \
	-DSDL_RPATH=OFF \
	-DSDL_RPI=OFF \
	-DSDL_SHARED=ON \
	-DSDL_SNDIO_SHARED=ON \
	-DSDL_STATIC=ON \
	-DSDL_STATIC_PIC=ON \
	-DSDL_TESTS=ON \
	-DSDL_TESTS_TIMEOUT_MULTIPLIER=$(test_timeout_multiplier) \
	-DSDL_TEST_LIBRARY=ON \
	-DSDL_VENDOR_INFO="${DEB_VENDOR} ${DEB_VERSION}" \
	-DSDL_VIVANTE=OFF \
	-DSDL_X11=ON \
	-DSDL_X11_SHARED=OFF \
	-DSDLTEST_TIMEOUT_MULTIPLIER=$(test_timeout_multiplier) \
	$(NULL)

ifneq ($(filter %-tests,$(built_binaries)),)
  confflags += -DSDL_INSTALL_EXAMPLES=ON
  confflags += -DSDL_INSTALL_TESTS=ON
endif

ifeq ($(filter %-doc,$(built_binaries)),)
  confflags += -DSDL_INSTALL_DOCS=OFF
else
  confflags += -DSDL_INSTALL_DOCS=ON
endif

ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
  confflags += -DSDL_ALTIVEC=OFF
endif

ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
  confflags += -DSDL_ALTIVEC=OFF
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  confflags += -DSDL_PIPEWIRE_SHARED=ON
  confflags += -DSDL_WAYLAND=ON
  confflags += -DSDL_WAYLAND_LIBDECOR_SHARED=OFF
  confflags += -DSDL_WAYLAND_SHARED=OFF
else
  confflags += -DSDL_WAYLAND=OFF
endif

#ifeq ($(DEB_VERSION_UPSTREAM),3.2.14~git20250513+ds)
#  confflags += -DSDL_REVISION=release-3.2.12-30-gc038d6f7f
#endif

%:
	dh $@ -Scmake+ninja -Bbuild

override_dh_auto_configure:
	set -e; for bmp in test/icon.bmp test/gamepad_*.bmp test/glass.bmp; do \
		python3 cmake/xxd.py -i "$${bmp}" -o "$${bmp%.bmp}.h"; \
	done
	cd build-scripts && ./makecasefoldhashtable.pl > ../src/stdlib/SDL_casefolding.h
	cd src/render/gpu/shaders && LC_ALL=C bash -ex ./build-shaders.sh
	# This is intended as a Windows batch file, but at the time of writing
	# it's so simple that it's also a valid shell script
	cd src/render/vulkan && sh -ex ./compile_shaders.bat
	cd test/testgpu && OSTYPE=$(DEB_HOST_ARCH_OS) bash -ex ./build-shaders.sh
	cp debian/placeholders/testgpu_*.h test/testgpu/
	dh_auto_configure -- $(confflags)

execute_after_dh_auto_build:
ifneq ($(filter %-doc,$(built_binaries)),)
	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile
	cd docs && doxygen ../debian/Doxyfile
	# useless files
	find docs/output -name "*.md5" -delete
	find docs/output -type d -empty -delete
endif

# Only run testtimer as an autopkgtest on machines that we're reasonably
# sure are both fast and set up to be usable for interactive use
# (currently only x86 and 64-bit ARM).
# There is an assertion that requesting a 1ms delay does not result in
# a delay of more than 100ms, and that's not going to be reliably true
# on slow machines like riscv64 or batch-processing-oriented machines
# like s390x.
ifeq (,$(filter amd64 arm64 i386,$(DEB_HOST_ARCH)))
execute_after_dh_auto_install:
	rm -fv debian/tmp/usr/share/installed-tests/SDL3/testtimer.test
endif

execute_after_dh_auto_clean-indep:
	rm -f debian/Doxyfile
	rm -rf docs/output

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-examples -Xusr/libexec/installed-tests
ifneq ($(filter %-tests,$(built_binaries)),)
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl3-tests/usr/libexec/installed-examples
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl3-tests/usr/libexec/installed-tests
endif

override_dh_installchangelogs:
	dh_installchangelogs -- WhatsNew.txt

=== debian/watch ===
Version: 5

# Upstream releases official source tarballs, so we use
# those in preference to git tags
Source: https://github.com/libsdl-org/SDL/tags
Matching-Pattern: .*/releases/tag/(?:release)-?@ANY_VERSION@
Compression: xz
Download-Url-Mangle: s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/SDL3-$2.tar.gz#
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Filename-Mangle: s#(?:prerelease|preview|release)-?@ANY_VERSION@#SDL3-$1.tar.gz#
Pgp-Mode: auto
Repack: yes
Repack-Suffix: +ds

## libsdl3 3.2.28+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 # See docs/release_checklist.md
-project(SDL3 LANGUAGES C VERSION "3.2.26")
+project(SDL3 LANGUAGES C VERSION "3.2.28")
 
 if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
   set(SDL3_MAINPROJECT ON)

=== debian/changelog ===
libsdl3 (3.2.28+ds-2) unstable; urgency=medium

  * d/p/build-scripts-Include-SDL-prefix-in-SDL_REVISION-when-bui.patch:
    Mark as applied upstream
  * d/p/Added-Keychron-V5-System-Control-to-the-controller-blackl.patch,
    d/p/testver-Assert-that-SDL_GetRevision-starts-with-SDL.patch,
    d/p/GPU-Remove-erroneous-buffer-usage-flag-from-defrag-proces.patch,
    d/p/log-Fix-unlikely-out-of-bounds-issue.patch,
    d/p/Fix-loop-variable-bug-in-V4L2-camera-format-enumeration.patch,
    d/p/WhatsNew.txt-Moved-some-missing-entries-over-to-the-relea.patch,
    d/p/stb_image.h-apply-patches-from-mainstream-PRs-1839-1862-a.patch,
    d/p/GPU-Fix-crash-on-Android-upon-returning-from-the-backgrou.patch,
    d/p/cmake-add-reftable-ref-storage-support-to-GetGitRevisionD.patch,
    d/p/Pass-the-window-along-with-evdev-touch-events.patch,
    d/p/Fix-SDL_EnumerateDirectory-failing-on-POSIX-and-Windows.patch,
    d/p/x11-Don-t-poll-the-map-state-when-the-window-was-unmapped.patch,
    d/p/wayland-Update-the-HDR-data-on-placeholder-displays.patch,
    d/p/Fix-for-13094.patch,
    d/p/egl-Better-attempt-at-retrying-surface-creation-w-o-EGL_E.patch,
    d/p/video-Unload-GL-Vulkan-when-shutting-down-the-video-subsy.patch,
    d/p/Allow-the-offscreen-and-dummy-drivers-to-be-used-as-fallb.patch,
    d/p/wayland-Use-the-implicit-grab-serial-when-clearing-the-cl.patch,
    d/p/Document-SDL-s-policy-on-setuid-setgid-executables.patch:
    Update to upstream commit release-3.2.28-27-g888104f5a from the
    release-3.2.x branch, excluding commits specific to upstream CI or
    non-Debian platforms
  * d/p/unix-Add-internal-function-SDL_CanUseGtk.patch,
    d/p/unix-If-setuid-or-setgid-don-t-use-GTK.patch,
    d/p/wayland-If-GTK-is-disabled-try-to-avoid-libdecor-s-GTK-pl.patch:
    Work around some SDL 1.2 and SDL 2 games being setgid
    (Closes: #1123953)

 -- Simon McVittie <smcv@debian.org>  Tue, 30 Dec 2025 17:33:59 +0000

libsdl3 (3.2.28+ds-1) unstable; urgency=medium

  * New upstream stable release
  * Drop patches that were included in the upstream release
  * d/p/build-scripts-Include-SDL-prefix-in-SDL_REVISION-when-bui.patch,
    d/p/dist/SDL_revision.h-Include-SDL-prefix-in-SDL_REVISION.patch:
    Add the expected SDL- prefix to SDL_REVISION

 -- Simon McVittie <smcv@debian.org>  Wed, 03 Dec 2025 17:03:25 +0000

## libsdl3 3.2.30+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 # See docs/release_checklist.md
-project(SDL3 LANGUAGES C VERSION "3.2.28")
+project(SDL3 LANGUAGES C VERSION "3.2.30")
 
 if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
   set(SDL3_MAINPROJECT ON)

=== debian/changelog ===
libsdl3 (3.2.30+ds-1+24.04+noble+unstable+build1) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Wed, 21 Jan 2026 08:12:04 +0000

libsdl3 (3.2.30+ds-1) unstable; urgency=medium

  * New upstream release
  * Drop most patches, applied upstream

 -- Simon McVittie <smcv@debian.org>  Thu, 01 Jan 2026 10:59:35 +0000

=== debian/control ===
Source: libsdl3
X-Style: black
Priority: optional
Section: libs
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>,
           Felix Geyer <fgeyer@debian.org>,
           Simon McVittie <smcv@debian.org>
Standards-Version: 4.7.2
Build-Depends: cmake,
               debhelper-compat (= 13),
               fcitx-libs-dev,
               glslang-tools (>= 12),
               libasound2-dev [linux-any],
               libdbus-1-dev,
               libdecor-0-dev (>= 0.2.0) [linux-any],
               libdrm-dev [linux-any],
               libegl-dev,
               libgbm-dev [linux-any],
               libgl-dev,
               libgles-dev,
               libibus-1.0-dev,
               libpipewire-0.3-dev (>= 0.3.44) [linux-any],
               libpulse-dev,
               libsndio-dev,
               libudev-dev [linux-any],
               liburing-dev [linux-any],
               libusb2-dev [kfreebsd-any],
               libusbhid-dev [kfreebsd-any],
               libvulkan-dev,
               libwayland-dev [linux-any],
               libx11-dev,
               libxcursor-dev,
               libxext-dev,
               libxfixes-dev,
               libxi-dev,
               libxinerama-dev,
               libxkbcommon-dev,
               libxrandr-dev,
               libxss-dev,
               libxt-dev,
               libxv-dev,
               libxxf86vm-dev,
               ninja-build,
               pkgconf,
               wayland-protocols,
               xxd
Build-Depends-Indep: doxygen <!nodoc>, graphviz <!nodoc>
Homepage: https://www.libsdl.org/
Vcs-Git: https://invent.kde.org/neon/backports-noble/libsdl3-noble.git
Vcs-Browser: https://invent.kde.org/neon/backports-noble/libsdl3-noble
Maintainer: Neon CI <neon@kde.org>

Package: libsdl3-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libdbus-1-3,
            libegl1,
            libgl1 | libopengl0,
            libgles2,
            libudev1 [linux-any]
Suggests: libayatana-appindicator3-1 | libappindicator3-1,
          libpipewire-0.3-0t64 [linux-any],
          liburing2 [linux-any],
          libvulkan1,
          xdg-utils
Description: Simple DirectMedia Layer, version 3
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the shared library.

Package: libsdl3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libasound2-dev [linux-any],
         libdbus-1-dev,
         libdecor-0-dev (>= 0.2.0) [linux-any],
         libdrm-dev [linux-any],
         libegl-dev,
         libgbm-dev [linux-any],
         libgl-dev,
         libgles-dev,
         libibus-1.0-dev,
         libpipewire-0.3-dev (>= 0.3.44) [linux-any],
         libpulse-dev,
         libsdl3-0 (= ${binary:Version}),
         libsndio-dev,
         libudev-dev [linux-any],
         libusb2-dev [kfreebsd-any],
         libusbhid-dev [kfreebsd-any],
         libwayland-dev [linux-any],
         libx11-dev,
         libxcursor-dev,
         libxext-dev,
         libxfixes-dev,
         libxi-dev,
         libxinerama-dev,
         libxkbcommon-dev,
         libxrandr-dev,
         libxss-dev,
         libxt-dev,
         libxv-dev,
         libxxf86vm-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Simple DirectMedia Layer, version 3 development files
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Breaks: libsdl1.2-dev (<< 1.2.64)
Replaces: libsdl1.2-dev (<< 1.2.64)
Description: Reference manual for SDL 3
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the reference manual and examples.

Package: libsdl3-tests
Section: misc
Architecture: any
Build-Profiles: <!noinsttest>
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: gnome-desktop-testing
Description: Simple DirectMedia Layer automated and manual tests
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains manual and automated tests. The automated tests can
 be run using ginsttest-runner in the gnome-desktop-testing package,
 or manually.
